//+------------------------------------------------------------------+
//|                                                     Sig_Soch.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_width1 2 
#property indicator_width2 2

extern bool Al=false;
extern int Length = 8;
extern double Ldown = -0.8;
extern double Lup = 0.8;
extern int Indent = 10;
double Zero, Zero_back;
double BufUp[];
double BufDn[];
int s,b,pos;
bool New_Bar=false;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   
   SetIndexBuffer(0, BufUp);
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexArrow(0, 233);
   
   SetIndexBuffer(1, BufDn);
   SetIndexStyle(1, DRAW_ARROW);
   SetIndexArrow(1, 234);
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int i, 
       Counted_bars=IndicatorCounted();
   i=Bars-Counted_bars-1;
//----
      while(i>=1)                      //         
      {      
        
         Zero=iCustom(NULL,0,"StochasticRVI 2",Length,0,i);
         Zero_back=iCustom(NULL,0,"StochasticRVI 2",Length,0,i+1);
         
         if (Zero<Ldown && Zero>Zero_back) {BufUp[i]=Low[i]-Indent*Point;pos=i;Comment("***BUY***", "");b=b+1;s=0;
         }
         if (Zero>Lup && Zero<Zero_back) {BufDn[i]=High[i]+Indent*Point;pos=i;Comment("***SELL***", "");s=s+1;b=0; 
         }       
         i--;                          //    
              
      }
      Fun_New_Bar();                               //   -
      if (New_Bar==false)                          //    ..
      return (0);	
      if (b>0 && Al==true) {Alert(Symbol()+" Drive Point UP "+Close[pos]);}
      if (s>0 && Al==true) {Alert(Symbol()+" Drive Point DOWN "+Close[pos]);}
//----
   return(0);
  }
//+------------------------------------------------------------------+
void Fun_New_Bar()                              // -  ..
  {                                             // ..  
   static datetime New_Time=0;                  //   
   New_Bar=false;                               //   
   if(New_Time!=Time[0])                        //  
     {
      New_Time=Time[0];                         //   
      New_Bar=true;                             //   
     }
  }